﻿local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")
local Tooltip = AceLibrary("Gratuity-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Quests")
L:RegisterTranslations("enUS", function() return {

	["Quests"] = true,
	["Filter"] = true,
	["Filter out quests"] = true,
    
    ["Module description"] = "Questgiver mapnotes for Cartographer",
  
	["Select all"] = true,
	["Select none"] = true,

    ["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,  
    ["Show minimap icons"] = true,
    ["Show quest icons on the minimap"] = true,
    ["Show minimap tracking icons"] = true,
    ["Show quest tracking icons on the minimap"] = true,
    
    ["Import"] = true,
    ["Import quests"] = true,
    ["Rebuild"] = true,
    ["Rebuild quests"] = true,
    
    ["Quest"] = true,
    ["Quest Giver"] = true,
    ["Default"] = true,
    ["Available"] = true,
    ["Active"] = true,
    
} end)

L:RegisterTranslations("koKR", function() return {

	["Quests"] = "퀘스트",
	["Filter"] = "필터",
	["Filter out quests"] = "퀘스트 아웃 필터",
    
    ["Module description"] = "맵노트에 퀘스트 제공자를 표시합니다.",
  
	["Select all"] = "모두 선택",
	["Select none"] = "선택 없음",

	["Icon alpha"] = "아이콘 투명도",
	["Alpha transparency of the icon"] = "아이콘의 투명도를 조절합니다.",
	["Icon size"] = "아이콘 크기",
	["Size of the icons on the map"] = "아이콘의 크기를 조절합니다.",
	["Show minimap icons"] = "미니맵 아이콘 보기",
    ["Show quest icons on the minimap"] = "미니맵에 퀘스트 제공자 아이콘을 표시합니다.",
    ["Show minimap tracking icons"] = true,
    ["Show quest tracking icons on the minimap"] = true,
    
    ["Import"] = true,
    ["Import quests"] = true,
    ["Rebuild"] = true,
    ["Rebuild quests"] = true,
	
    ["Quest"] = "퀘스트",
    ["Quest Giver"] = "퀘스트 제공자",
    ["Default"] = "기본값",
    ["Available"] = "가능",
    ["Active"] = "활성화",
    
} end)

L:RegisterTranslations("deDE", function() return {

	["Quests"] = "Quests",
	["Filter"] = "Filter",
	["Filter out quests"] = "Quests filtern",
	
    ["Module description"] = "Questgeber-Kartennotizen f\195\188r Cartographer",  

    ["Select all"] = "Alles ausw\195\164hlen",
    ["Select none"] = "Nichts ausw\195\164hlen",
    
    ["Icon alpha"] = "Transparenz",
    ["Alpha transparency of the icon"] = "Transparenz der Symbole",
    ["Icon size"] = "Symbolgr\195\182\195\159e",
    ["Size of the icons on the map"] = "Gr\195\182\195\159e des Symbols auf der Karte",    
    ["Show minimap icons"] = "Zeige Minimap Symbole",
    ["Show quest icons on the minimap"] = "Zeige Quest Symbole auf der Minimap",
    ["Show minimap tracking icons"] = "Zeige Minimap Sucher Symbole",
    ["Show quest tracking icons on the minimap"] = "Zeige Quest Sucher Symbole auf der Minimap",

    ["Import"] = "Import",
    ["Import quests"] = "Importiere Quests",
    ["Rebuild"] = "Erneuere",
    ["Rebuild quests"] = "Erneuere Quests",
    
    ["Quest"] = "Quest",
    ["Quest Giver"] = "Questgeber",
    ["Default"] = "Standard",
    ["Available"] = "Verf\195\188gbar",
    ["Active"] = "Aktiv",
} end)

L:RegisterTranslations("zhTW", function() return {

--	["Quests"] = true,
	["Filter"] = "篩檢",
	["Filter out quests"] = "篩檢任務",
	
    ["Module description"] = "Cartographer 任務給予人地圖註記",
  
	["Select all"] = "全部選擇",
	["Select none"] = "全部取消",

    ["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,  
    ["Show minimap icons"] = true,
    ["Show quest icons on the minimap"] = true,
    ["Show minimap tracking icons"] = true,
    ["Show quest tracking icons on the minimap"] = true,

    ["Import"] = true,
    ["Import quests"] = true,
    ["Rebuild"] = true,
    ["Rebuild quests"] = true,
   
    ["Quest"] = "任務",
    ["Quest Giver"] = "任務給予人",
    ["Default"] = "預設",
    ["Available"] = "可取得",
    ["Active"] = "開啟",

} end)

L:RegisterTranslations("esES", function() return {

	["Quests"] = "Misiones",
	["Filter"] = "Filtrar",
	["Filter out quests"] = "Filtra misiones",

    ["Module description"] = "Notas de mapa de proveedores de misi\195\179n para Cartographer",
  
	["Select all"] = "Seleccionar todo",
	["Select none"] = "No seleccionar nada",
    
    ["Icon alpha"] = "Transparencia de icono",
    ["Alpha transparency of the icon"] = "Transparencia del icono",
    ["Icon size"] = "Tama\195\177o del icono",
    ["Size of the icons on the map"] = "Tama\195\177o de los iconos en el mapa",
    ["Show minimap icons"] = "Mostrar iconos en minimapa",
    ["Show quest icons on the minimap"] = "Muestra los iconos de misiones en el minimapa",
    ["Show minimap tracking icons"] = "Mostrar iconos de seguimiento en minimapa",
    ["Show quest tracking icons on the minimap"] = "Muestra los iconos de seguimiento de misiones en el minimapa",

    ["Import"] = "Importar",
    ["Import quests"] = "Importa misiones",
    ["Rebuild"] = "Reconstruir",
    ["Rebuild quests"] = "Reconstruye misiones",
   
    ["Quest"] = "Misi\195\179n",
    ["Quest Giver"] = "Proveedor de misi\195\179n",
    ["Default"] = "Por defecto",
    ["Available"] = "Disponible",
    ["Active"] = "Activo",
    
} end)

Cartographer_Quests = Cartographer:NewModule("Quests", "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
Cartographer_Quests:RegisterDB("Cartographer_QuestsDB")

Cartographer_Quests.filters = {
    ["Quest"] = L["Quest"],
}
 
Cartographer_Quests.lookups = {
    ["filters"] = {},
}

Cartographer_Quests.icons = {
	["Quest"] = {
		text = L["Quest"],
		path = "Interface\\AddOns\\Cartographer_Quests\\Artwork\\INV_Misc_Book_08",
		width = 14,
		height = 14
	},
}

Cartographer_Quests.givers = {}

Cartographer_Quests.noteDefaults = {
	titleCol = Cartographer_Notes.getColorID(0, 0.8, 0)
}

Cartographer_Quests.noteLocaleHandler = L

function Cartographer_Quests:OnInitialize()
	self:RegisterDefaults("profile", {
		filters = {
			['*'] = true,
		},
        iconAlpha = 1,
		iconScale = 1,
        minimapIcons = true,
        minimapTracking = true,
        noteRadius = 15,        
	})
    
    self:RegisterDefaults("faction", {
        givers = {
            ['*'] = {
                ['*'] = {},
            },
        },
    })

	local aceopts = {}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}

	aceopts.alpha = {
		name = L["Icon alpha"],
		desc = L["Alpha transparency of the icon"],
		type = 'range',
		min = 0.1,
		max = 1,
		step = 0.05,
		isPercent = true,
		get = "GetIconAlpha",
		set = "SetIconAlpha",
		order = 1
	}
	aceopts.scale = {
		name = L["Icon size"],
		desc = L["Size of the icons on the map"],
		type = 'range',
		min = 0.5,
		max = 2,
		step = 0.05,
		isPercent = true,
		get = "GetIconScale",
		set = "SetIconScale",
		order = 2
	}
    aceopts.minimapicons = {
		name = L["Show minimap icons"],
		desc = L["Show quest icons on the minimap"],
		type = 'toggle',
		set = "ToggleShowingMinimapIcons",
		get = "IsShowingMinimapIcons",
		order = 3,
	}
    
    aceopts.minimaptracking = {
        name = L["Show minimap tracking icons"],
        desc = L["Show quest tracking icons on the minimap"],
        type = 'toggle',
        set = function() 
            self.db.profile.minimapTracking = not self.db.profile.minimapTracking
            Cartographer_Notes:RefreshMap()
        end,
        get = function() return self.db.profile.minimapTracking end,
        order = 4,
        hidden = function() return not self.db.profile.minimapIcons end,
    }    
    
	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out quests"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.filters) do
						self:ToggleShowingQuests(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.filters) do
						self:ToggleShowingQuests(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}    
    
    aceopts.rebuild = {
        name = L["Rebuild"],
        desc = L["Rebuild quests"],
        type = 'execute',
        func = "RebuildQuests",
        order = 6,
        hidden = true,
    }    
    
	Cartographer.options.args["Quests"] = {
		name = L["Quests"],
		desc = L["Module description"],
		type = 'group',
		args = aceopts,
		handler = self,
	}
	-- AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args["Quests"])
    
	for k,v in pairs(self.filters) do
		local k = k
		aceopts.filter.args[k] = {
			name = v,
			desc = v,
			type = 'toggle',
			get = function()
				return self:IsShowingQuests(k)
			end,
			set = function(value)
				return self:ToggleShowingQuests(k, value)
			end,
		}
	end    
    
    if (not self.db.faction.notes) then self.db.faction.notes = {} end

    local oldDB = Cartographer:AcquireDBNamespace("Quests")
    if (oldDB.faction.notes) then
        for k, v in pairs(oldDB.faction.notes) do
            if (k ~= "version") and (v ~= nil) then
                if (not self.db.faction.notes[k]) then self.db.faction.notes[k] = {} end
                for vk, vv in pairs(v) do
                    if (vv ~= nil) then
                        if (not self.db.faction.notes[k][vk]) then
                            -- self.db.faction.notes[k][vk] = {}
                            self.db.faction.notes[k][vk] = vv
                        end
                    end
                end
            end
        end
    end
    oldDB = nil
end

function Cartographer_Quests:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icons) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end

		Cartographer_Notes:RegisterNotesDatabase('Quests', self.db.faction.notes, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end

    -- self:RegisterEvent("GOSSIP_SHOW", 2)
    -- self:RegisterEvent("QUEST_DETAIL", function() self:RegisterQuest(UnitName("NPC"), GetTitleText()) end, 2)
    -- self:RegisterEvent("QUEST_DETAIL", function() self:RegisterQuestGiver(UnitName("npc")) end, 2)
    self:RegisterEvent("QUEST_DETAIL", "RegisterQuestGiver", 2)
end

function Cartographer_Quests:OnDisable()
	self:UnregisterAllEvents()

	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Quests')
	end
end

function Cartographer_Quests:SetNote(giver)
    if (type(giver) == "string") then giver = {["name"] = giver} end
    if (type(giver) ~= "table") then return end
    
    if (not giver.x) or (not giver.y) then giver.x, giver.y = GetPlayerMapPosition("player") end
    if (giver.x == 0) and (giver.y == 0) then return end
    
    if (not giver.zone) then giver.zone = GetRealZoneText() end
    
    local note = {}
    note.title = giver.name
    note.icon = "Quest"
    note.info = "Quest Giver"
    
    --[[
    if (giver.quests) then
        if (giver.quests.available) then
            note.info = ""
            for k, v in ipairs(giver.quests.available) do
                if (v ~= nil) then
                    if (note.info:len() == 0) then note.info = L["Available"] .. ":\n"
                    else note.info = note.info .. "\n" end
                    note.info = note.info .. v.title
                end
            end
        end

        if (giver.quests.active) then
            note.info2 = ""
            for k, v in ipairs(giver.quests.active) do
                if (v ~= nil) then
                    if (note.info2:len() == 0) then note.info2 = L["Active"] .. ":\n"
                    else note.info2 = note.info2 .. "\n" end
                    note.info2 = note.info2 .. v.title
                end
            end
        end

        note.title = note.title .. " - " .. L["Quest Giver"]
    end    
    --]]
    
    for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(giver.zone, giver.x, giver.y, (self.db.profile.noteRadius or 20), "Quests", nil, true) do
        if (data.title == note.title) then
            Cartographer_Notes:DeleteNote(zone, x_p, y_p)
        end
    end
    
    Cartographer_Notes:SetNote(giver.zone, giver.x, giver.y, note.icon, "Quests", note)
end



function Cartographer_Quests:GOSSIP_SHOW()
    -- self:Debug("GOSSIP_SHOW")
    
    local giver = UnitName("NPC")
    
    t1,l1, t2,l2, t3,l3, t4,l4, t5,l5 = GetGossipActiveQuests()
    t1,l1, t2,l2, t3,l3, t4,l4, t5,l5 = GetGossipAvailableQuests()
   
end

function Cartographer_Quests:RegisterQuestGiver()
    if (UnitIsPlayer("npc") or UnitPlayerControlled("npc")) then return end 
    giver = UnitName("npc")
    if (type(giver) ~= "string") then return end
    if (giver:len() == 0) then return end
    
    local zone = GetRealZoneText()
    local x,y = GetPlayerMapPosition("player")

    local entry = {}    
    if (not self.db.faction.givers[zone][giver]) then
        entry.x = x
        entry.y = y
        Tooltip:SetUnit("npc")
        local result = Tooltip:GetLine(2)
        if (result) then entry.type = result end
        entry.faction = UnitFactionGroup("player")
        
        self.db.faction.quests[zone][giver] = entry
    end
    
    entry = self.db.faction.givers[zone][giver]
    if (not entry.name) then entry.name = giver end
    if (not entry.zone) then entry.zone = zone end

    self:SetNote(entry)
end


function Cartographer_Quests:RegisterQuest(giver, quest)
    if (not giver) then return end
    if (type(giver) ~= "string") then return end
    
    if (not quest) then return end
    if (type(quest) == "string") then
        local name = quest
        quest = {}
        quest.name = name
    end
    if (type(quest) ~= "table") then return end
    
    if (not mod.givers) then mod.givers = {} end
    if (not mod.givers[giver]) then 
        mod.givers[giver] = {} 
        mod.givers[giver].name = giver
    end
    if (not mod.givers[giver].quests) then mod.givers[giver].quests = {} end
    -- if (not mod.givers[giver].quests.active) then mod.givers[giver].quests.active = {} end
    -- if (not mod.givers[giver].quests.available) then mod.givers[giver].quests.available = {} end
    
    local match = false
    for k, v in ipairs(mod.givers[giver].quests) do
        if (v ~= nil) then
            if (v.name == quest.name) then 
                match = true
                break
            end
        end
    end
    if (not match) then table.insert(mod.givers[giver].quests, quest) end
    
    self:SetNote(mod.givers[giver])
end

function Cartographer_Quests:IsNoteHidden(zone, id, quest)
	if type(quest) == "table" then
		return not self.db.profile.filters[quest.icon]
	else
		return not self.db.profile.filters[quest]
	end
end

function Cartographer_Quests:IsShowingQuests(questtype)
	return self.db.profile.filters[questtype]
end

function Cartographer_Quests:ToggleShowingQuests(questtype, value)
	if value == nil then
		value = not self.db.profile.filters[questtype]
	end
	self.db.profile.filters[questtype] = value

	Cartographer_Notes:RefreshMap()
end

function Cartographer_Quests:IsTracking(zone,id,data)
    return true
end

function Cartographer_Quests:IsShowingMinimapIcons()
	return self.db.profile.minimapIcons
end

function Cartographer_Quests:ToggleShowingMinimapIcons()
	self.db.profile.minimapIcons = not self.db.profile.minimapIcons
end

function Cartographer_Quests:IsMiniNoteHidden(zone,id,data)
	return not self.db.profile.minimapIcons
end

function Cartographer_Quests:GetIconScale()
	return self.db.profile.iconScale
end

function Cartographer_Quests:SetIconScale(value)
	self.db.profile.iconScale = value
	Cartographer_Notes:RefreshMap()
end
function Cartographer_Quests:GetIconAlpha()
	return self.db.profile.iconAlpha
end

function Cartographer_Quests:SetIconAlpha(value)
	self.db.profile.iconAlpha = value
	Cartographer_Notes:RefreshMap()
end

function Cartographer_Quests:GetNoteTransparency(zone,id,data)
	return self.db.profile.iconAlpha
end

function Cartographer_Quests:GetNoteScaling(zone,id,data)
	return self.db.profile.iconScale
end

function Cartographer_Quests:RebuildQuests()
end
